<?php
include_once(dirname(dirname(__FILE__)).'/classes/ChatRequestRemote.php');
class FLASHCHAT_CTRL_Admin extends ADMIN_CTRL_Abstract
{
	private function getMenu(){
        $menuItems = array();

        $item = new BASE_MenuItem();
        $item->setLabel( OW::getLanguage()->text('123flashchat', 'Settings') );
        $item->setUrl( OW::getRouter()->urlForRoute('123flashchat_settings') );
        $item->setKey( 'settings' );
        $item->setIconClass( 'ow_ic_gear_wheel' );
        $item->setOrder( 0 );
        array_push( $menuItems, $item );

        $item = new BASE_MenuItem();
        $item->setLabel( OW::getLanguage()->text('123flashchat', 'Admin Panel') );
        $item->setUrl( OW::getRouter()->urlForRoute('123flashchat_adminpanel') );
        $item->setKey( 'adminpanel' );
        $item->setIconClass( 'ow_ic_server' );
        $item->setOrder( 1 );
        array_push( $menuItems, $item );

        return new BASE_CMP_ContentMenu( $menuItems );
    }
    
	public function index(){
		
		$language = OW::getLanguage(); 
        $this->setPageHeading( OW::getLanguage()->text('123flashchat', 'chat_setting') );
                
        $this->addComponent( 'menu', $this->getMenu() );
        $this->getComponent( 'menu' )->getElement( 'settings' )->setActive( true );

        $fc_setting = FLASHCHAT_BOL_FlashchatDao::getInstance()->getSettings();
        $this->assign('setting', $fc_setting);
        $this->assign('valid', FLASHCHAT_CLASS_Flashchat::getInstance()->getValid($fc_setting));
        $this->assign('serverhost', $_SERVER['HTTP_HOST']);
        $this->assign('homeurl', OW_URL_HOME);
        
         
//var_dump(OW::getPluginManager()->getPlugin($plugin_chat_name)->getRootDir());
//var_dump(OW::getLanguage()->importPluginLangs(OW::getPluginManager()->getPlugin($plugin_chat_name)->getRootDir() . 'langs.zip', 'flashchat'));
//var_dump(OW::getLanguage()->importPluginLangs(OW::getPluginManager()->getPlugin($plugin_chat_name)->getRootDir() . 'langs.zip', '123flashchat'));
//exit;

        $configSaveForm = new ConfigSaveForm();

        $this->addForm($configSaveForm);

        if ( OW::getRequest()->isPost() && $configSaveForm->isValid($_POST) ){
            $res = $configSaveForm->process();
            $this->redirect(OW::getRouter()->urlForRoute('123flashchat_settings'));
        }
        
    }
    
    public function adminpanel(){
    	$language = OW::getLanguage(); 
        $this->setPageHeading( OW::getLanguage()->text('123flashchat', 'chat_admin_panel') );
        
        $this->addComponent( 'menu', $this->getMenu() );
        $this->getComponent( 'menu' )->getElement( 'adminpanel' )->setActive( true );  
        
        $fc_setting = FLASHCHAT_BOL_FlashchatDao::getInstance()->getSettings();
        $swfurl = FLASHCHAT_CLASS_Flashchat::getInstance()->getChatUrl($fc_setting,true);
        
        $this->assign('setting', $fc_setting);
        $this->assign('swfurl', $swfurl);
    }
}

class ConfigSaveForm extends Form{
	public function __construct(){
		parent::__construct('configSaveForm');

        $language = OW::getLanguage();
       
        // submit
        $submit = new Submit('save');
        $submit->setValue($language->text('123flashchat', 'btn_save'));
        $this->addElement($submit);

	}
	
	public function process(){
		$extendserver = isset($_POST['extendserver']) ? $_POST['extendserver'] : 2;
		$data->extendserver = $extendserver;
		$data->servertype = isset($_POST['servertype']) ? $_POST['servertype'] : 0;		
		switch ($extendserver){
			case 0:
				$data->client_loc = !empty($_POST['client_loc']) ? $_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '') : '';
            	if($data->client_loc){
            		$serverinfo = $this->getServerHostPortLocal($data->client_loc);
            		$data->server_host = !empty($_POST['server_host']) ? $_POST['server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
            		$data->server_host_s = empty($serverinfo['fc_server_host_s']) ? $data->server_host : $serverinfo['fc_server_host_s'];
            		$data->server_host_h = empty($serverinfo['fc_server_host_h']) ? $data->server_host : $serverinfo['fc_server_host_h'];
            		if(!is_numeric($_POST['server_port']) || strpos($_POST['server_port'] ,".")!==false){
            			$data->server_port = empty($serverinfo['fc_server_port']) ? ( $data->servertype == 1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
            		}else{
            			$data->server_port = $_POST['server_port'];
            		}
            		if(!is_numeric($_POST['server_port_h']) || strpos($_POST['server_port_h'] ,".")!==false){
            			$data->server_port_h = empty($serverinfo['fc_server_port_h']) ? ( $data->servertype == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
            		}else{
            			$data->server_port_h = $_POST['server_port_h'];
            		}
            		$data->server_port_s = empty($serverinfo['fc_server_port_s']) ? ( $data->servertype == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
            		$data->api_url = 'http://' . $data->server_host . ':' . $data->server_port_h . '/';
            	}else{
            		$data->server_host = $_SERVER['HTTP_HOST'];
            		$data->server_host_h = $data->server_host_s = $data->server_host;
            		if($data->servertype == 1){
            			$data->server_port_h = '31212';
            			$data->server_port_s = '51213';
            			$data->server_port = '51212';
            		}else{
            			$data->server_port_h = '35555';
            			$data->server_port_s = '51128';
            			$data->server_port = '51127';
            		}
            		$data->api_url = 'http://' . $data->server_host . ':' . $data->server_port_h . '/';
            		$data->client_loc = $data->api_url;
            	}
            	$s_own_loc = 1;
	            $c_own_loc = 1;
	            $da = 1;
	            if($_POST['server_loc']){
	            	$c_own_loc = FLASHCHAT_CLASS_Flashchat::getInstance()->validate_client($data->client_loc);
            		$da = FLASHCHAT_CLASS_Flashchat::getInstance()->validate_data_api($data->api_url . 'online.js');
		            if($c_own_loc || $da){
	            		OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'client_location_or_http_port_error'));
						return false;
	            	}
	            	$this->_valid = 0;
	            }else{
	            	$c_own_loc = FLASHCHAT_CLASS_Flashchat::getInstance()->validate_client($data->client_loc);
	            	if($c_own_loc){
	            		OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'client_location_or_http_port_error'));
						return false;
	            	}
	            }
            	$check = FLASHCHAT_CLASS_Flashchat::getInstance()->validate_client('http://'.parse_url($data->client_loc, PHP_URL_HOST).':'.$data->server_port_h.'/');
            	if($check){
            		OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'client_location_error'));
					return false;
            	}
				break;
			case 1:
				$data->client_loc = !empty($_POST['client_loc']) ? $_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '') : '';
				if($data->client_loc == ""){
					OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'client_location_is_empty'));
					return false;
				}
				$serverinfo = $this->getServerHostPortHost($data->client_loc);
				if($serverinfo){					
					$data->server_host = empty($serverinfo['fc_server_host']) ? parse_url($data->client_loc, PHP_URL_HOST) : $serverinfo['fc_server_host'];
					$data->server_host_s = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
					$data->server_host_h = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
					$data->server_port = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
					$data->server_port_h = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
            		$data->server_port_s = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
            		$data->api_url = 'http://' . $data->server_host . '/';
            		$data->group = substr(parse_url($data->client_loc, PHP_URL_PATH),1,-1);
					$c_own_loc = FLASHCHAT_CLASS_Flashchat::getInstance()->validate_client($data->client_loc);
					$da = FLASHCHAT_CLASS_Flashchat::getInstance()->validate_data_api($data->api_url . 'online.js?group=' . $data->group);
			        if($c_own_loc || $da){
						OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'client_location_error'));
						return false;
			        }
				}else{
					OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'client_location_error'));
					return false;
				}
				break;
			case 2:
				$room = $_POST['room'];
				if(trim($room) != ''){
					preg_match("/\w+$/", $room,$matches);
					if(strlen($room) != strlen($matches[0])){
						OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'chat_name_error'));
						return false;
					}
					$data->room = $room;
				}else{
					$data->room = 'Lobby';
				}
				break;
		}
		if($data->servertype == 1){
			$data->clienttype = 0;
		}else{
			$data->clienttype = isset($_POST['clienttype']) ? $_POST['clienttype'] : 0;
		}
		$data->fullscreen = isset($_POST['fullscreen']) ? $_POST['fullscreen'] : 1;
		$data->room_list = isset($_POST['room_list']) ? $_POST['room_list'] : 1;
		$data->user_list = isset($_POST['user_list']) ? $_POST['user_list'] : 1;
		$data->client_width = (is_numeric($_POST['client_width']) && $_POST['client_width'] >= 700) ? $_POST['client_width'] : 700;
		$data->client_height = (is_numeric($_POST['client_height']) && $_POST['client_height'] >= 642) ? $_POST['client_height'] : 642;
		$data->client_lang = isset($_POST['client_lang']) ? $_POST['client_lang'] : "auto";
		$data->client_skin = isset($_POST['client_skin']) ? $_POST['client_skin'] : "default";
		
		OW::getFeedback()->info(OW::getLanguage()->text('123flashchat', 'save_success'));
		return FLASHCHAT_BOL_FlashchatDao::getInstance()->setSettings($data);
	}
	
	public function getServerHostPortLocal($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
		if ($content){
			//server host
		 	preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host'] = '';
		        }
	        }
	        //server port
	        preg_match('/init_port = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port'] = '';
	        }
	        //server host s
			preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_s'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_s'] = '';
		        }
	        }
	        //server port s
	        preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_s'] = '';
	        }
	        //server host h
			preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_h'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_h'] = '';
		        }
	        }
	        //server port h
	        preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_h'] = '';
	        }
	        return $data;
	    }else{
	    	return false;
	    }
	}
	
	public function getServerHostPortHost($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location,1);
		if ($content){
			//server port
			preg_match('/init_port=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }
	        //server port s
			preg_match('/init_port_s=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }
	        //server port h
			preg_match('/init_port_h=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }
	        //server host
			preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }
	        //server host s
			preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }
	        //server host h
			preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }
	        return $data;
	    }else{
            return false;
	    }
	}
}